
true CONSTANT testing
0 CONSTANT lagring   \ skjermskriv

\ : /string   DUP >R - SWAP R> + SWAP ;
\ : 0>   0 > ;
\ : D>S   DROP ;
\ : D2*   2DUP D+ ;
\ : D-   DNEGATE D+ ;
\ : D<   D- DROP 0< ;
\ : M+   S>D D+ ;
\ : FALSE 0 ;   : TRUE -1 ;
\ : .s   .S ;
\ : 0<>   0 <> ;
\ 0 CONSTANT r/o

\ Diverse generelle funksjonar----------------------------

\ : UNDER+  ROT + SWAP ;   \ trengst i Swiftforth
\ : -ROT ROT ROT ;
\ : NOOP ;                 \ trengst i VFX
\ : NOT 0= ;               \ trengst i Gforth

: cell-  [ 1 CELLS ] LITERAL - ;   \ back up one cell
: S=  ( a u a u - flagg ) COMPARE 0= ;   \ trengst i Gforth

\ : sqrt   ( n1 -- n2 )   \ trengst i Gforth
\	-1 SWAP OVER DO 2 + DUP +LOOP 2/ ;		\ wil
	
testing [IF]
VARIABLE pauseflagg
: +pause   -1 pauseflagg ! ;
: -pause    0 pauseflagg ! ;   -pause
: pause
   pauseflagg @
   IF
      .S CR KEY [CHAR] q =
      IF ." QUIT utført" CR QUIT THEN
   THEN ;
[THEN]
\ --------------------------------------------------


\ : ??  \ by Wil Baden: IF <word> THEN
\   S" IF" EVALUATE BL WORD COUNT EVALUATE  S" THEN" EVALUATE ;
\   IMMEDIATE 

\ STRENGAR ----------------------------------------------------

: kvit? ( c -- flagg ) \ sann for blanke/styreteikn/255
   [CHAR] ! - 222 U< 0= ;

: kscan ( a u -- a u ) \ flytt strengstart til 1. kvite
   BEGIN DUP
   WHILE OVER C@ kvit?
      IF   EXIT THEN
      1 under+ 1 -
   REPEAT ;

: kskip ( a u -- a u ) \ flytt strengstart til 1. ikkje-kvite
   BEGIN DUP
   WHILE OVER C@ kvit? 0=
      IF   EXIT THEN
      1 under+ 1 -
   REPEAT ;

\ del frå 1. ord frå venstre
: 1.ord ( a1 u1 -- a2 u2 a3 u3 ) \ 2= reststreng 3= funne ord
   kskip 2DUP kscan
   2DUP 2>R NIP - 2R> 2SWAP ;

: siffer? ( adr - flagg )
   C@ [CHAR] 0 - 10 U< ;  
   
\ : CPACK ( adr1 adr2 u - ) \ flytt og pakk streng 1 til 2
\    SWAP 2DUP C!   1+ SWAP CMOVE ;
   
: del-linje ( a u -- a u ... n ) \ n= antal ord
    DEPTH >R
    BEGIN
        1.ord ( rest funn )
        DUP   ( rest a u u )
    WHILE
        2SWAP ( funn rest )
    REPEAT
    2DROP 2DROP
    DEPTH R> - 2 + 2/   \ antall frå depth-auke
    ;
	
: dropp ( au au au au ... n -- )   \ alle delstrengar
	?DUP IF
		1 - 0 swap DO 2drop -1 +LOOP 
	THEN ;

\ --------------par --------------
: (FM/)  FM/MOD NIP ;

: k+    ROT + ROT ROT + SWAP ;
: k-      ROT SWAP - ROT ROT - SWAP ;
: k*      ROT * ROT ROT * SWAP ;  ( a b c d -- a*c b*d )
: km*   ROT M* 2>R M* 2R> ;     ( a b c d -- a*c . b*d . )
: k*/   2>R km* R> (FM/) ROT ROT R> (FM/) SWAP ; ( k1 k2 k3 -- k1*k2/k3 )
: k.    SWAP 7 .R 9 .R ;
: k+!   DUP ROT SWAP +! CELL+ +! ;
: k2/   2/ swap 2/ swap ;
: k/    rot swap / rot rot / swap ;
: k-diff ( pkt1 . pkt2 . -- dx dy )  \ jfr k- og D-
    2SWAP k- ( dx dy ) ;
: k2dup   2over 2over ; ( a b c d -- a b c d a b c d )
\ ----------------------------------------------------------
	
: styv ( a u -- a u1 ) 2DUP kscan NIP - ;

\  ************************	 NUMBER	 NUMBER?  ************************
VARIABLE NH

: desimalteikn?      ( C -- FLAG )
    DUP [CHAR] : = SWAP [CHAR] + - 5 U< OR ;
	
: NOT-A-NUMBER   S" 2DROP 0 EXIT " EVALUATE ; IMMEDIATE

: meir? ( a u -- a u f )
	OVER C@ desimalteikn?
	\	 Reject	successive punctuations.
	OVER DPL @ <>	AND ;
	
: tall?   \ ( STR LEN -- 0 | NUM 1 | NUM . 2 )   \ jfr NUMBER?
    -1 DPL !
    \  reject empty string.
    DUP 0= IF   NOT-A-NUMBER   THEN
    OVER C@ [CHAR] - =  DUP NH !  1 AND /string
    \  reject lone minus sign.
    DUP 0= IF   NOT-A-NUMBER   THEN
    \  reject double minus sign.
    OVER C@ [CHAR] - = IF   NOT-A-NUMBER   THEN
    \  reject lone punctuation.
    DUP 1 = IF 
    	OVER C@ desimalteikn? IF   NOT-A-NUMBER   THEN
    THEN

	0.	2SWAP					 ( num . str len)
	BEGIN	>NUMBER DUP ( d. a u rest? )
		IF   meir?   ELSE 0   THEN
	WHILE	
		1	/string	 DUP DPL !
	REPEAT					 ( num . str len)
	
    ?DUP AND IF                 ( NUM . STR)
        C@ BL - IF   NOT-A-NUMBER   THEN
    THEN                        ( NUM .)
    NH @ IF   DNEGATE   THEN
    DPL @ 0< IF  NH !  1  ELSE  2  THEN \ orig wil
	;


\  ************************	 End of	NUMBER	*************************

  VARIABLE f#places
\ number of	digits to the right	of the implied decimal point

: places ( n --	)  0 MAX  f#places ! ;
\ specify the number of	digits behind the decimal point

  3	places	\ default 5
\ default setting gives	a total	resolution of 5+1	digits

\ {	--------------------------------------------------------------------
\  Number conversion
\  --------------------------------------------------------------------	}

: shift	( n1 n -- n2)
  DUP 0<
  IF	NEGATE
		0	 DO	 10	/  LOOP
  ELSE	0 ?DO  10 *	LOOP	 THEN ;
\ perform decimal right	shift (n<0)	or left	shift (n>0)

\ dpl: underforstått desimalantal i n
: fixa	( n dpl -- f)   \ oppskaler med dpl og f#places
  f#places @  swap 0 MAX  -  shift ;

: fix0	( n dpl -- f)   \ oppskaler med dpl
  0  swap 0 MAX  -  shift ;

\ dpl: underforstått desimalantal i n
\ : fix4	( n dpl -- f)   \ konverter til fixnr 4 sifre er desimalar
\  4  swap 0 MAX  -  shift ;
\ {	--------------------------------------------------------------------
\  Numeric output words
\  --------------------------------------------------------------------	}

: (X.) ( f -- addr len)
  DUP  ABS 0
  <#  f#places @ 0 ?DO # LOOP  [CHAR] ,	HOLD  #S  ROT SIGN	#> ;
\ convert a	fixed point	number to a	formatted string

: X. ( f --	)  (X.)	TYPE  SPACE	;
\ display a	fixed point	number

: X.R (	f width	-- )  >R  (X.)	R> OVER - SPACES	 TYPE ;
\ display a	fixed point	number right justified in a	field of specified width

\ {	==================================================================== }

1 CELLS 8 * CONSTANT BITS/CELL \ sett lik cellestorleik !

\ kvdratrot----------------------------------------
\ enkelpresisjon
: iSQRT  ( n -- n ) DUP IF    \   startklokke
	>R 1   \ seed @ 
	R@ OVER / OVER + 2/ NIP
	BEGIN R@ OVER / OVER + 2/ 2DUP > WHILE NIP REPEAT  drop ( seed ! ) RDROP 
	THEN \ stoppklokke 
; 
\ dobbelpresisjon
\ kvadratrot, treng provisorisk rot som startverdi
: dkvr ( d1 rot0 -- d1 . r2 r1 ) \ rot0 er startverdi
	begin
		>R 2dup  ( d1 . d1 . )
		R@ um/mod nip        ( d1 . r2 )
		R>                ( d1 . r2 r1 )
		2dup - abs 1 >
	while
		+ 2 /
	repeat ;

: kvrot2 ( d rot0 -- rot )  dkvr 2swap 2drop drop ; \ med startrot
\ kvadratrot, krev ikkje provisorisk rot som startverdi inn
: kvrot1 ( d -- rot ) 100 dkvr 2swap 2drop drop ; \ utan startrot

\ ----------------
\ kypotenuskvadrat hypo2
: hypo2 ( katet1 katet2 -- hypo^2 . ) 2DUP km* D+ ;

: hypotenus ( katet1 katet2 -- hypotenus ) hypo2 d>S isqrt ;

: hypotenus2 ( katet1 katet2 -- hypo2 . hypotenus )
	over             ( dx dy dx )
	hypo2 ( dx h*h . )
	rot    abs    ( h*h . dx )
	dkvr       ( h*h . r2 r1 )
	drop ;

: hypotenus3 ( katet1 katet2 -- hypotenus ) hypotenus2 rot rot 2drop ;

\ ----------------------trippel-------------------------------
: 3variable ( -- ) CREATE 3 CELLS ALLOT ;
: 3! ( n2 n1 n0 a -- )
    SWAP OVER !
    CELL+ SWAP OVER !
    CELL+ ! ;

: 3@ ( a -- n2 n1 n0 )
     DUP CELL+ 2@
    ROT @ ;
	
0 [IF]
: 3@ ( a -- n n n ) DUP @ SWAP CELL+ DUP @ SWAP CELL+ @ ;
: 3! ( n n n a -- ) DUP >R CELL+ CELL+ !  R@ CELL+ !  R> ! ;
: Tnegate ( n1 n2 n3 -- -n1 -n2 -n3 )
	NEGATE ROT NEGATE ROT NEGATE ROT ;
: T-   ( t2 . . t1 . . -- dx dy dz ) \ som k-, men trippel
	>R ROT R> - >R ROT SWAP - ROT ROT - SWAP R> ;

: T+   ( t2 . . t1 . . -- sumx sumy sumz ) \ som k+, men trippel
	>R ROT R> + >R ROT + ROT ROT + SWAP R> ;

: Thypo ( x y z -- n ) \ 3D-hypotenus
	>R DUP M* ROT DUP M* D+
	R> DUP M* D+ dsqrt ;

: snu ( n1 n2 n3 -- n3 n2 n1 ) SWAP ROT ; \ overswap
: .xyz ( x y z -- ) snu   12 X.R 12 X.R 12 X.R ;
[THEN]

\ -----------------------------------------------------
\ oppbevaring av min og max
\ liknar VALUE, 
\ men utan startverdi og med til for TO
\ run ( -- nmin nmax )

TRUE 1 RSHIFT CONSTANT stort	\ største tall
stort 1+ CONSTANT lite
0 VALUE %val
: til -1 TO %val ; \ ( n -- ) \ bruk som TO

: maxmin+-: CREATE lite , stort , DOES> %val  ( a flag )
	IF  ( n1 a )
		2DUP  DUP @   ROT MAX SWAP ! 
		CELL+ DUP @   ROT MIN SWAP !
		0 TO %val
	ELSE 
		2@ ( nmin nmax )
	THEN ;
	
\ run ( -- nmin nmax antal )
: logg: CREATE lite , stort , 0 , DOES> %val  ( a flag )
	IF  ( n1 a )
		2DUP  DUP @   ROT MAX SWAP ! 
		CELL+ dup rot rot
		DUP @   ROT MIN SWAP !
		0 TO %val
		CELL+  1 swap +!
	ELSE 
		3@ rot ( nmin nmax antal ) 
	THEN ;
\ --------------------------------------------------------
: .xy ( x y -- ) swap   12 X.R 12 X.R ;

: .xyh ( x y h -- ) rot rot .xy 10 X.R ;

2variable starttid
: startklokke ." 0 mikrosek" utime  starttid 2! ;
: stoppklokke
	utime starttid 2@ d- ( 1000 um/mod nip )  d. ." mikrosekund" ;
\ ..............................................................

: num>S ( n -- a u )
	S>D
	SWAP OVER DABS   <# 32 HOLD #S ROT SIGN #> ;