\ provisorisk orientering  ----------------------------

: siktretn ( snr -- Rv ) \ i iu-eining
	koo-diff R>P nip ;

variable #orienterte     \ antall retningsobs med orientering

: TrengOri? ( siktnr -- f )
	OV{ OVER } @ 0=          \ manglar ori
	HVvekt{ ROT } @ 0= 0=    \ har hv
	AND ;

: HarOrientering? ( snr -- f )
	OV{ OVER } @ 0>     \ ov=0 rv=0 er tillatte verdiar
	RV{ ROT } @ 0> OR ; \ dekker tilfeller med ein nullvinkel

: SammeOnr? ( onr snr -- f ) \ 
	ORNR{ SWAP } @ = ;

: kopier ( ov snr -- ) \ kopier ov til snr
	2DUP OV{ SWAP } !  \ ny ov
	HV{ OVER } @ ROT ret+ SWAP RV{ SWAP } ! \ ny rv
	1 #orienterte +!  ." Os" ;

: SpreOV ( snr -- ) \ orienter andre sikt i samme stasjonen
	DUP OV{ SWAP } @  SWAP ORNR{ SWAP } @ ( ov onr )
	AlleSikt DO ( ov onr )
		DUP I SammeOnr? ( ov onr f1 ) 
		I TrengOri? AND ( ov onr f ) IF  OVER I kopier  THEN
	LOOP 2DROP ;

: OrKoo ( snr -- )
	DUP siktretn ( >einingIU ) ( snr rv )
	2DUP SWAP RV{ SWAP } ! ( snr rv )
	OVER HV{ SWAP } @ ( snr rv hv )
	ret- SWAP OV{ SWAP } ! 
	1 #orienterte +!  ." Ok" ;

: OrienterAvKoo ( snr -- )
	DUP toendekoo? IF  DUP OrKoo SpreOV  ELSE  DROP  THEN ;

: motsiktnr ( snr -- msnr ) \ siktnr i motsett retning
	endenr ( fnr tnr )
	AlleSikt DO
		2DUP I endenr  ( fnr tnr fnr tnr f' t ' )
		SWAP D= ( f )  \ motsett sikt?
		IF
			2DROP I UNLOOP EXIT    \ funne
		THEN
	LOOP 2DROP -888 ;         \ =ikkje funne
	
: motsikt? ( snr -- f ) \ motsatt retta, (polart) og orientert
	motsiktnr ( gsnr ) DUP 0< 0= ( gsnr f ) \ siktnr og ok-flagg
	SWAP HarOrientering? AND ;

: OrMot ( snr -- ) \ orienter sikt frå motsett retta sikt
	DUP motsiktnr ( snr msnr )
	RV{ SWAP } @ SnuRv  ( snr rv' )
	2DUP RV{ ROT } ! 
	OVER HV{ SWAP } @ ret- ( snr ov )
	OVER SWAP OV{ ROT } !  DROP \ Siste!
	1 #orienterte +!  ." Om" ;

: OrienterAvMotsikt ( snr -- )
	DUP motsikt? IF  DUP OrMot SpreOV  ELSE  DROP  THEN ;

: ProvOr ( -- )  \ provisoriske rvinklar og ovinklar
	0 #orienterte !  \ -999 SisteStasjon !   \ 999=ugyldig
	AlleSikt DO
		i TrengOri?  IF  i OrienterAvKoo  THEN
		i TrengOri?  IF  i OrienterAvMotsikt  THEN
	LOOP ;

\ provisorisk polar -----------------------------------------

: lengdeobs ( snr -- vv L )
	LS{ OVER } @ SWAP VV{ SWAP } @ SWAP ;
	
: horlengde@ ( snr -- Lhor )
	DUP lengdeobs ( snr vv L )
	DUP IF  
		ROT DROP ( vv L )
	ELSE
		2DROP motsiktnr DUP 0< IF DROP 0 0 ELSE lengdeobs ( vv L ) THEN
	THEN 
	DUP IF SWAP horisontrer ELSE DROP THEN ;
	
: MotMeg? ( tilnr siktnr --f )
	tilpkt = ( f ) ; \ går til aktuelt pkt
	
: FraKoo@ ( snr -- x y )
	frapkt XY{ SWAP } 2@ ;

: Retnv@  ( snr -- rv )  RV{ SWAP } @ ;

: Polarobs@ ( snr -- x y rv Lhor )
	DUP FraKoo? 0= IF  DROP 0 0 0 0 EXIT ( 0 0 0 0 ) THEN ( snr )
	DUP FraKoo@ ( snr x y )
	ROT DUP ( x y snr snr )
	HarOrientering? 0= IF  0  EXIT ( x y snr 0 ) THEN ( x y snr )
	DUP Retnv@  ( x y snr rv )
	SWAP horlengde@ ;
	
: Obs@ ( tilnr snr -- x y rv Lhor )
	SWAP OVER MotMeg? ( snr f )
	IF  Polarobs@  ELSE  0 0 0  THEN ;

 : polarsikt ( tilnr -- x y rv Lhor ) \ finn sikt mot tilnr
	AlleSikt DO 
		 ( tilnr ) DUP I  Obs@ ( tilnr x y rv Lhor )
		 DUP IF   UNLOOP 4 ROLL DROP EXIT   THEN
		 2DROP 2DROP
	LOOP DROP 0 0 0 0 ;
	
: polarkoo ( x y rv Lhor -- x y )
	P>R ( x y dx dy )
	k+ ;

: polar2 ( pnr -- x y f )
	polarsikt ( x y rv Lhor ) 
	DUP IF polarkoo -1 ELSE nip nip 0 THEN ;

: polar1 ( pnr -- )   
	DUP Polar2  ( pnr x y f ) IF
		2>R DUP 2R> ROT XY{ SWAP } 2!  
		DUP 1 opphav{ ROT } ! ( pnr )
		GiNr ." P"
	ELSE
		2DROP DROP
	THEN ;

: ProvPolar ( -- )
	AllePkt DO
		I Har-Koo? 0= IF  
			I polar1
		THEN
	LOOP ;

